commit b1360be37d7346ae086539b0846acd36f5f43255
Author: Marcos Mendoza <mmendoza@netgate.com>
Date:   Fri Sep 27 15:02:49 2024 -0600

    Clean up diffs

diff --git a/src/etc/inc/config.lib.inc b/src/etc/inc/config.lib.inc
index c04301c260..72343c9dee 100644
--- a/src/etc/inc/config.lib.inc
+++ b/src/etc/inc/config.lib.inc
@@ -28,6 +28,7 @@
 
 require_once("xmlparse.inc");
 require_once('util.inc');
+require_once('globals.inc');
 
 /****f* config/encrypted_configxml
  * NAME
@@ -713,31 +714,27 @@ function reset_factory_defaults($lock = false, $reboot_required = true) {
 	return 0;
 }
 
-function config_restore($conffile) {
-	global $g;
-
-	if (!file_exists($conffile)) {
-		return 1;
+function config_restore(string $path, string $descr): bool {
+	if (!file_exists($path) || !backup_config()) {
+		return false;
 	}
 
-	backup_config();
-
 	$lockkey = lock('config', LOCK_EX);
 	if (!isset($lockkey)) {
-		return 1;
+		return false;
 	}
 	unlink_if_exists(g_get('tmp_path'). '/config.cache');
-	$copy_result = copy($conffile, "{$g['cf_conf_path']}/config.xml");
+	$copy_result = copy($path, g_get('cf_conf_path') . '/config.xml');
 	unlock($lockkey);
 
 	if ($copy_result) {
 		disable_security_checks();
 		config_read_file(true);
-		write_config(sprintf(gettext("Reverted to %s."), array_pop(explode("/", $conffile))), false);
-		return 0;
+		write_config(sprintf(gettext('Reverted to "%s"'), $descr), false);
+		return true;
 	}
 
-	return 1;
+	return false;
 }
 
 function config_install($conffile) {
@@ -934,38 +931,32 @@ function get_backups() {
 	return $toreturn;
 }
 
-function backup_config() {
-	global $g;
+function backup_config(): bool
+{
+	$backup_dir = g_get('cf_conf_path') . '/backup';
 
 	/* Create backup directory if needed */
-	safe_mkdir("{$g['cf_conf_path']}/backup");
-	if (config_get_path('revision/time') == "") {
-		$baktime = 0;
-	} else {
-		$baktime = config_get_path('revision/time');
-	}
+	safe_mkdir($backup_dir);
 
-	if (config_get_path('revision/description') == "") {
-		$bakdesc = "Unknown";
-	} else {
-		$bakdesc = config_get_path('revision/description');
-	}
+	/* Generate config backup file name */
+	$backup_time = config_get_path('revision/time', 0);
+	$backup_file = $backup_dir . '/config-' . $backup_time . '.xml';
 
+	/* Handle backup cache */
+	$bakdesc = config_get_path('revision/description', 'Unknown');
 	$bakver = config_get_path('version', "?");
-	$bakfilename = g_get('cf_conf_path') . '/backup/config-' . $baktime . '.xml';
-	copy(g_get('cf_conf_path') . '/config.xml', $bakfilename);
-
 	if (file_exists(g_get('cf_conf_path') . '/backup/backup.cache')) {
 		$backupcache = unserialize_data(file_get_contents(g_get('cf_conf_path') . '/backup/backup.cache'), []);
 	} else {
 		$backupcache = array();
 	}
-	$backupcache[$baktime] = array('description' => $bakdesc, 'version' => $bakver, 'filesize' => filesize($bakfilename));
+	$backupcache[$backup_time] = array('description' => $bakdesc, 'version' => $bakver, 'filesize' => filesize($backup_file));
 	$bakout = fopen(g_get('cf_conf_path') . '/backup/backup.cache', "w");
 	fwrite($bakout, serialize($backupcache));
 	fclose($bakout);
 
-	return true;
+	/* Do the backup */
+	return copy(g_get('cf_conf_path') . '/config.xml', $backup_file);
 }
 
 function backup_info($backup_info, $number) {
diff --git a/src/etc/inc/filter.inc b/src/etc/inc/filter.inc
index f723eaa3ca..10db346d38 100644
--- a/src/etc/inc/filter.inc
+++ b/src/etc/inc/filter.inc
@@ -515,6 +515,7 @@ function filter_configure_sync($delete_states_if_needed = true) {
 	 * 'cpzoneid_X_auth' - add PASS tag to authenticated client
 	 */
 	$rules .= filter_captiveportal_ether();
+	$rules .= PHP_EOL;
 
 	update_filter_reload_status(gettext("Setting up SCRUB information"));
 	$rules .= filter_generate_scrubbing();
diff --git a/src/etc/inc/openvpn.inc b/src/etc/inc/openvpn.inc
index f6362ba8ab..ce14bf1f85 100644
--- a/src/etc/inc/openvpn.inc
+++ b/src/etc/inc/openvpn.inc
@@ -864,7 +864,7 @@ function openvpn_reconfigure($mode, $settings) {
 	$pfile = g_get('varrun_path') . "/openvpn_{$mode_id}.pid";
 	$proto = strtolower($settings['protocol']);
 	if (substr($settings['protocol'], 0, 3) == "TCP") {
-			$proto = "{$proto}-{$mode}";
+		$proto = "{$proto}-{$mode}";
 	}
 	$dev_mode = $settings['dev_mode'];
 	$fbcipher = $settings['data_ciphers_fallback'];
@@ -1391,6 +1391,7 @@ function openvpn_reconfigure($mode, $settings) {
 	if ($settings['mode'] == "p2p_shared_key") {
 		$conf .= "cipher {$fbcipher}\n";
 	} else {
+		/* Build data ciphers list from configuration. */
 		$conf .= "data-ciphers " . str_replace(',', ':', openvpn_build_data_cipher_list($settings['data_ciphers'], $fbcipher)) . "\n";
 		$conf .= "data-ciphers-fallback {$fbcipher}\n";
 	}
@@ -1445,7 +1446,9 @@ function openvpn_reconfigure($mode, $settings) {
 	}
 
 	// If the server is not a TLS server or it has a tunnel network CIDR less than a /30, skip this.
-	if (in_array($settings['mode'], $openvpn_tls_server_modes) && (!empty($ip) && !empty($mask) && ($cidr < 30)) && $settings['dev_mode'] != "tap") {
+	if (in_array($settings['mode'], $openvpn_tls_server_modes) &&
+	    (!empty($ip) && !empty($mask) && ($cidr < 30)) &&
+	    ($settings['dev_mode'] != "tap")) {
 		if (empty($settings['topology'])) {
 			$settings['topology'] = "subnet";
 		}
@@ -1535,14 +1538,10 @@ function openvpn_reconfigure($mode, $settings) {
 	}
 }
 
-function openvpn_restart($mode, $settings) {
+function openvpn_stop_process($mode, $settings) {
 	global $g;
 
-	$vpnid = $settings['vpnid'];
 	$mode_id = openvpn_name($mode, $settings, 'generic');
-	$lockhandle = lock("openvpnservice{$mode_id}", LOCK_EX);
-	openvpn_reconfigure($mode, $settings);
-	/* kill the process if running */
 	$pfile = g_get('varrun_path')."/openvpn_{$mode_id}.pid";
 	if (file_exists($pfile)) {
 
@@ -1566,6 +1565,16 @@ function openvpn_restart($mode, $settings) {
 			$i++;
 		}
 	}
+}
+
+function openvpn_restart($mode, $settings) {
+	global $g;
+
+	$vpnid = $settings['vpnid'];
+	$mode_id = openvpn_name($mode, $settings, 'generic');
+	$lockhandle = lock("openvpnservice{$mode_id}", LOCK_EX);
+	openvpn_reconfigure($mode, $settings);
+	openvpn_stop_process($mode, $settings);
 
 	if (isset($settings['disable'])) {
 		openvpn_delete($mode, $settings);
@@ -1602,6 +1611,7 @@ function openvpn_restart($mode, $settings) {
 	$res = mwexec("/usr/local/sbin/openvpn --config " . escapeshellarg($fpath));
 	if ($res == 0) {
 		$i = 0;
+		$pfile = g_get('varrun_path')."/openvpn_{$mode_id}.pid";
 		$pid = "--";
 		while ($i < 3000) {
 			if (isvalidpid($pfile)) {
@@ -1627,17 +1637,7 @@ function openvpn_delete($mode, $settings) {
 	$vpnid = $settings['vpnid'];
 	$mode_id = openvpn_name($mode, $settings, 'generic');
 
-	/* kill the process if running */
-	$pfile = "{$g['varrun_path']}/openvpn_{$mode_id}.pid";
-	if (file_exists($pfile)) {
-
-		/* read the pid file */
-		$pid = trim(file_get_contents($pfile));
-		unlink($pfile);
-
-		/* send a term signal to the process */
-		posix_kill($pid, SIGTERM);
-	}
+	openvpn_stop_process($mode, $settings);
 
 	/* destroy the device */
 	pfSense_interface_destroy(openvpn_name($mode, $settings));
diff --git a/src/etc/inc/pfsense-utils.inc b/src/etc/inc/pfsense-utils.inc
index a58843e25f..a1a3ac24dd 100644
--- a/src/etc/inc/pfsense-utils.inc
+++ b/src/etc/inc/pfsense-utils.inc
@@ -1233,7 +1233,8 @@ function setup_loader_settings($path = "", $upgrade = false) {
 		$vga_only = true;
 	} elseif ($specific_platform['name'] == 'Turbot Dual-E') {
 		$g['primaryconsole_force'] = "video";
-	} elseif ($specific_platform['name'] == 'RCC-VE' ||
+	} elseif (
+	    $specific_platform['name'] == 'RCC-VE' ||
 	    $specific_platform['name'] == 'RCC' ||
 	    $specific_platform['name'] == 'SG-2220' ||
 	    $specific_platform['name'] == 'apu2') {
@@ -2028,7 +2029,10 @@ function compare_hostname_to_dnscache($hostname) {
  * load_crypto() - Load crypto modules if enabled in config.
  */
 function load_crypto() {
-	$crypto_modules = array('aesni', 'cryptodev');
+	$crypto_modules = [
+		'aesni',
+		'cryptodev'
+	];
 
 	$enabled_modules = explode('_', config_get_path('system/crypto_hardware'));
 
diff --git a/src/etc/inc/pkg-utils.inc b/src/etc/inc/pkg-utils.inc
index 271cbdcdc8..f05f09fa6d 100644
--- a/src/etc/inc/pkg-utils.inc
+++ b/src/etc/inc/pkg-utils.inc
@@ -59,13 +59,17 @@ function pkg_valid_name($pkgname) {
 	return preg_match($pattern, $pkgname);
 }
 
-/* Remove pkg_prefix from package name if it's present */
+/* Remove pkg_prefix or flavor_prefix from package name if it's present */
 function pkg_remove_prefix(&$pkg_name) {
-	global $g;
-
-	if (substr($pkg_name, 0, strlen(g_get('pkg_prefix'))) ==
-	    g_get('pkg_prefix')) {
-		$pkg_name = substr($pkg_name, strlen(g_get('pkg_prefix')));
+	$pres = [g_get('pkg_prefix')];
+	if (!is_null(g_get('flavor_prefix'))) {
+		$pres[] = g_get('flavor_prefix');
+	}
+	foreach ( $pres as $pre) {
+		if (str_starts_with($pkg_name, $pre)) {
+			$pkg_name = substr($pkg_name, strlen($pre));
+			break;
+		}
 	}
 }
 
@@ -1556,43 +1560,50 @@ function pkg_switch_repo() {
 function update_repos() {
 	$product_name = g_get('product_name');
 	$pipes = [];
-	$descriptorspec = [
-		1 => ["pipe", "w"], /* stdout */
-		2 => ["pipe", "w"]  /* stderr */
+	$dspec = [
+		1 => ['pipe', 'w'], /* stdout */
+		2 => ['pipe', 'w']  /* stderr */
 	];
 	$rc = -1;
 	/* Default error message for failure cases. */
 	$fail_error = [
 		"error" => 1,
-		"messages" => ["Could not update connect to Netgate servers. Please try again later."]
+		"messages" => [gettext('Could not connect to Netgate servers. Please try again later.')]
 	];
 
 	/* Execute repoc with a full pkg style environment, including proxy
 	 * configuration. */
 	$process = proc_open(sprintf('/usr/local/sbin/%s-repoc -N', $product_name),
-	    $descriptorspec, $pipes, '/', pkg_env());
+	    $dspec, $pipes, '/', pkg_env());
 
 	/* Process failed to start */
 	if (!is_resource($process)) {
 		return $fail_error;
 	}
 
-	/* Read output */
-	$stdout = stream_get_contents($pipes[1]);
-	fclose($pipes[1]);
-	/* If stdout is boolean false, reading stdout failed. */
-	if ($stdout === false) {
-		return $fail_error;
-	}
-
-	/* Read errors */
-	$stderr = stream_get_contents($pipes[2]);
-	fclose($pipes[2]);
+	$timeout = 5; /* seconds */
+	$stdout = '';
+	do {
+		$start = microtime(true);
+		$r = ['stdout' => $pipes[1], 'stderr' => $pipes[2]];
+		$w = $e = null;
+		if (($n = stream_select($r, $w, $e, 0)) === false) {
+			$result = $fail_error;
+			goto error;
+		} else if ($n > 0) {
+			foreach ($r as $var => $fd) {
+				$$var .= fread($fd, 4096);
+			}
+		}
+		if (($timeout -= (microtime(true) - $start)) <= 0) {
+			$result = $fail_error;
+			goto error;
+		}
+	} while (!feof($pipes[1]) && !feof($pipes[2]));
 
 	/* Get return code */
-	$rc = proc_close($process);
 	$result = [
-		"error" => $rc,
+		"error" => proc_close($process),
 		"messages" => []
 	];
 
@@ -1600,13 +1611,18 @@ function update_repos() {
 	$stdout = explode("\n", trim($stdout));
 
 	if ((count($stdout) > 1) &&
-	    ($stdout[0] === "Messages:")) {
+	    ($stdout[0] === 'Messages:')) {
 		/* Copy over message content from the output. */
 		$result['messages'] = array_merge($result['messages'], array_slice($stdout, 1));
 	} elseif (!empty($stderr)) {
 		$result['messages'][] = $stderr;
 	}
 
-	return ($result);
+error:
+	if (is_resource($process)) {
+		proc_close($process);
+	}
+
+	return $result;
 }
 ?>
diff --git a/src/etc/inc/services.inc b/src/etc/inc/services.inc
index 2a0505f892..287764fe73 100644
--- a/src/etc/inc/services.inc
+++ b/src/etc/inc/services.inc
@@ -488,6 +488,8 @@ function services_kea6_configure() {
 	$kea_var_lib = '/var/lib/kea';
 	$kea_var_db = '/var/db/kea';
 
+	$kea6socket = g_get('varrun_path') . '/kea6-ctrl-socket';
+
 	if (g_get('services_dhcp_server_enable') == false) {
 		return;
 	}
@@ -552,7 +554,7 @@ function services_kea6_configure() {
 		'hooks-libraries' => [],
 		'control-socket' => [
 			'socket-type' => 'unix',
-			'socket-name' => '/var/run/kea6-ctrl-socket'
+			'socket-name' => $kea6socket
 		],
 	];
 
@@ -1004,7 +1006,7 @@ kea6_skip_first_pool_options:
 	$known_duids = array_keys($known_duids);
 	foreach ($known_duids as $duid) {
 		$keaconf['Dhcp6']['reservations'][] = [
-			'duid' => $duid
+			'duid' => (string) $duid
 		];
 	}
 
@@ -1126,6 +1128,8 @@ function services_kea4_configure() {
 	$kea_var_run = g_get('varrun_path') . '/kea';
 	$kea_var_lib = '/var/lib/kea';
 
+	$kea4socket = g_get('varrun_path').'/kea4-ctrl-socket';
+
 	if (g_get('services_dhcp_server_enable') == false) {
 		return;
 	}
@@ -1195,7 +1199,7 @@ function services_kea4_configure() {
 		'hooks-libraries' => [],
 		'control-socket' => [
 			'socket-type' => 'unix',
-			'socket-name' => '/var/run/kea4-ctrl-socket'
+			'socket-name' => $kea4socket
 		],
 	];
 
diff --git a/src/etc/inc/system.inc b/src/etc/inc/system.inc
index 67511ae64d..a72b00026b 100644
--- a/src/etc/inc/system.inc
+++ b/src/etc/inc/system.inc
@@ -26,6 +26,7 @@
  */
 
 require_once('config.lib.inc');
+require_once('services_dhcp.inc');
 require_once('syslog.inc');
 
 function system_hwpstate_active() {
@@ -204,6 +205,31 @@ function activate_sysctls() {
 	set_sysctl($sysctls);
 }
 
+/* Search current tunables for a specific OID and either update the existing
+ * entry or create a new one.
+ * Does not write the config, that's up to the caller. */
+function set_sysctl_config($oid, $value) {
+	$tunables = config_get_path('sysctl/item', []);
+	$updated = false;
+	$found = false;
+	foreach ($tunables as $idx => $tunable) {
+		if ($tunable['tunable'] == $oid) {
+			$found = true;
+			$tunables[$idx]['value'] = $value;
+		}
+	}
+	if (!$found) {
+		$tunables[] = [
+			'tunable' => $oid,
+			'value' => $value,
+		];
+		$updated = true;
+	}
+	if ($updated) {
+		config_set_path('sysctl/item', $tunables);
+	}
+}
+
 function system_resolvconf_generate($dynupdate = false) {
 	global $g;
 
@@ -730,9 +756,8 @@ function system_dhcpleases_configure() {
 }
 
 function system_get_kea6status() {
-	$socket_path = '/var/run/kea6-ctrl-socket';
+	$socket_path = g_get('varrun_path') . '/kea6-ctrl-socket';
 	$rbuf = NULL;
-	$ret = false;
 
 	if (!file_exists($socket_path)) {
 		goto out;
@@ -768,21 +793,15 @@ function system_get_kea6status() {
 		}
 	}
 
-	/* sanity check in case we received malformed json */
-	if (($ret = json_decode($retjson, true)) === false) {
-		goto cleanup;
-	}
-
 cleanup:
 	socket_close($fd);
 out:
-	return ($ret);
+	return (json_decode($retjson, true));
 }
 
 function system_get_kea4status() {
-	$socket_path = '/var/run/kea4-ctrl-socket';
+	$socket_path = g_get('varrun_path') . '/kea4-ctrl-socket';
 	$rbuf = NULL;
-	$ret = false;
 
 	if (!file_exists($socket_path)) {
 		goto out;
@@ -818,19 +837,14 @@ function system_get_kea4status() {
 		}
 	}
 
-	/* sanity check in case we received malformed json */
-	if (($ret = json_decode($retjson, true)) === false) {
-		goto cleanup;
-	}
-
 cleanup:
 	socket_close($fd);
 out:
-	return ($ret);
+	return (json_decode($retjson, true));
 }
 
 function system_clear_all_kea4leases() {
-	$socket_path = '/var/run/kea4-ctrl-socket';
+	$socket_path = g_get('varrun_path') . '/kea4-ctrl-socket';
 	$rbuf = NULL;
 
 	if (!file_exists($socket_path)) {
@@ -843,7 +857,8 @@ function system_clear_all_kea4leases() {
 	}
 
 	if (!socket_connect($fd, $socket_path, 0)) {
-		goto cleanup;
+		socket_close($fd);
+		return;
 	}
 
 	$cmdjson = json_encode(['command' => 'lease4-wipe']);
@@ -851,21 +866,13 @@ function system_clear_all_kea4leases() {
 	socket_send($fd, $cmdjson, strlen($cmdjson), 0);
 
 	/* Kea sends status that we are not really interested in, so just eat it */
-	for (;;) {
-		$bytes = socket_recv($fd, $rbuf, 8192, MSG_WAITALL);
-		if ($bytes > 0) {
-			continue;
-		}
+	while (socket_recv($fd, $rbuf, 8192, MSG_WAITALL) > 0);
 
-		break;
-	}
-
-cleanup:
 	socket_close($fd);
 }
 
 function system_del_kea4lease(string $ip) {
-	$socket_path = '/var/run/kea4-ctrl-socket';
+	$socket_path = g_get('varrun_path') . '/kea4-ctrl-socket';
 	$rbuf = NULL;
 
 	if (!file_exists($socket_path)) {
@@ -878,7 +885,8 @@ function system_del_kea4lease(string $ip) {
 	}
 
 	if (!socket_connect($fd, $socket_path, 0)) {
-		goto cleanup;
+		socket_close($fd);
+		return;
 	}
 
 	$cmdjson = json_encode([
@@ -891,21 +899,13 @@ function system_del_kea4lease(string $ip) {
 	socket_send($fd, $cmdjson, strlen($cmdjson), 0);
 
 	/* Kea sends status that we are not really interested in, so just eat it */
-	for (;;) {
-		$bytes = socket_recv($fd, $rbuf, 8192, MSG_WAITALL);
-		if ($bytes > 0) {
-			continue;
-		}
-
-		break;
-	}
+	while (socket_recv($fd, $rbuf, 8192, MSG_WAITALL) > 0);
 
-cleanup:
 	socket_close($fd);
 }
 
 function system_clear_all_kea6leases() {
-	$socket_path = '/var/run/kea6-ctrl-socket';
+	$socket_path = g_get('varrun_path') . '/kea6-ctrl-socket';
 	$rbuf = NULL;
 
 	if (!file_exists($socket_path)) {
@@ -918,7 +918,8 @@ function system_clear_all_kea6leases() {
 	}
 
 	if (!socket_connect($fd, $socket_path, 0)) {
-		goto cleanup;
+		socket_close($fd);
+		return;
 	}
 
 	$cmdjson = json_encode(['command' => 'lease6-wipe']);
@@ -926,21 +927,13 @@ function system_clear_all_kea6leases() {
 	socket_send($fd, $cmdjson, strlen($cmdjson), 0);
 
 	/* Kea sends status that we are not really interested in, so just eat it */
-	for (;;) {
-		$bytes = socket_recv($fd, $rbuf, 8192, MSG_WAITALL);
-		if ($bytes > 0) {
-			continue;
-		}
-
-		break;
-	}
+	while (socket_recv($fd, $rbuf, 8192, MSG_WAITALL) > 0);
 
-cleanup:
 	socket_close($fd);
 }
 
 function system_del_kea6lease(string $ip) {
-	$socket_path = '/var/run/kea6-ctrl-socket';
+	$socket_path = g_get('varrun_path') . '/kea6-ctrl-socket';
 	$rbuf = NULL;
 
 	if (!file_exists($socket_path)) {
@@ -953,7 +946,8 @@ function system_del_kea6lease(string $ip) {
 	}
 
 	if (!socket_connect($fd, $socket_path, 0)) {
-		goto cleanup;
+		socket_close($fd);
+		return;
 	}
 
 	$cmdjson = json_encode([
@@ -966,26 +960,17 @@ function system_del_kea6lease(string $ip) {
 	socket_send($fd, $cmdjson, strlen($cmdjson), 0);
 
 	/* Kea sends status that we are not really interested in, so just eat it */
-	for (;;) {
-		$bytes = socket_recv($fd, $rbuf, 8192, MSG_WAITALL);
-		if ($bytes > 0) {
-			continue;
-		}
+	while (socket_recv($fd, $rbuf, 8192, MSG_WAITALL) > 0);
 
-		break;
-	}
-
-cleanup:
 	socket_close($fd);
 }
 
-
 function system_get_kea6leases() {
 	$leases = [];
 	$leases['lease'] = [];
 	$leases['failover'] = [];
 
-	$socket_path = '/var/run/kea6-ctrl-socket';
+	$socket_path = g_get('varrun_path') . '/kea6-ctrl-socket';
 	$rbuf = NULL;
 
 	if (!file_exists($socket_path)) {
@@ -3132,7 +3117,8 @@ function system_get_serial() {
 
 	$vm_guest = get_single_sysctl('kern.vm_guest');
 
-	if (strlen($serial) >= 10 && strlen($serial) <= 16 &&
+	$serial = chop($serial);
+	if (strlen($serial) >= 10 && strlen($serial) <= 18 &&
 	    $vm_guest == 'none') {
 		return $serial;
 	}
@@ -3185,7 +3171,7 @@ function system_identify_specific_platform() {
 
 	if ($chassis[0] == "OracleCloud.com") {
 		return (array('name' => 'Oracle', 'descr' => 'Oracle Cloud Infrastructure'));
-	}	
+	}
 
 	if ($maker[0] == "QEMU") {
 		return (array('name' => 'QEMU', 'descr' => 'QEMU Guest'));
@@ -3382,5 +3368,3 @@ function system_get_arp_table($resolve_hostnames = false) {
 
 	return $arp_table;
 }
-
-?>
diff --git a/src/etc/inc/unbound.inc b/src/etc/inc/unbound.inc
index e8b6be3b5f..cee43de56f 100644
--- a/src/etc/inc/unbound.inc
+++ b/src/etc/inc/unbound.inc
@@ -27,6 +27,7 @@
 
 /* include all configuration functions */
 require_once("config.inc");
+require_once("services_dhcp.inc");
 require_once("functions.inc");
 require_once("filter.inc");
 require_once("shaper.inc");
diff --git a/src/etc/inc/upgrade_config.inc b/src/etc/inc/upgrade_config.inc
index 9657ecbd77..8f221a390b 100644
--- a/src/etc/inc/upgrade_config.inc
+++ b/src/etc/inc/upgrade_config.inc
@@ -6515,7 +6515,6 @@ function upgrade_220_to_221() {
 	config_set_path('widgets/sequence', implode(',', $widgets));
 }
 
-/* No functional changes. */
 function upgrade_221_to_222() {
 }
 
diff --git a/src/etc/inc/util.inc b/src/etc/inc/util.inc
index 8bc2d1a8b8..c0db058f40 100644
--- a/src/etc/inc/util.inc
+++ b/src/etc/inc/util.inc
@@ -24,6 +24,7 @@
  * See the License for the specific language governing permissions and
  * limitations under the License.
  */
+
 //require_once('interfaces.inc');
 require_once('Net/IPv6.php');
 define('VIP_ALL', 1);
@@ -48,6 +49,56 @@ define('SPECIALNET_VIPS', 12);
 define('SPECIALNET_CHECKPERM', 98);
 define('SPECIALNET_EXCLUDE', 99);
 
+/**
+ * Test the machine type
+ *
+ * @param string $arch		The architecture to test for
+ * @param bool $strict		Use strict architecture matching
+ *
+ * @return bool
+ */
+function is_arch(string $arch, bool $strict = false): bool
+{
+	$sys_arch = php_uname('m');
+	return (($arch == $sys_arch) || (!$strict && str_contains($sys_arch, $arch)));
+}
+
+/**
+ * Test if the machine type is any arm
+ *
+ * @return bool
+ */
+function is_arm(): bool
+{
+	return (is_arch('arm', false));
+}
+
+/**
+ * Test if the machine type is amd64
+ *
+ * @return bool
+ */
+function is_amd64(): bool
+{
+	return (is_arch('amd64', true));
+}
+
+/**
+ * Test if the machine type is arm64
+ */
+function is_arm64(): bool
+{
+	return (is_arch('arm64', true));
+}
+
+/**
+ * Test if the machine type is any 64bit
+ */
+function is_64bit(): bool
+{
+	return (is_amd64() || is_arm64());
+}
+
 /* kill a process by pid file */
 function killbypid($pidfile, $waitfor = 0) {
 	return sigkillbypid($pidfile, "TERM", $waitfor);
@@ -4674,4 +4725,3 @@ function unserialize_data(?string $path, mixed $default = null, ?array $options
 	return $data;
 }
 
-?>
diff --git a/src/etc/inc/xmlparse.inc b/src/etc/inc/xmlparse.inc
index 7d8f090df4..08c4cf58b3 100644
--- a/src/etc/inc/xmlparse.inc
+++ b/src/etc/inc/xmlparse.inc
@@ -41,8 +41,8 @@ function listtags() {
 		'field', 'fieldname',
 		'gateway_item', 'gateway_group', 'gif', 'gre', 'group',
 		'hash-algorithm-option', 'hosts', 'ifgroupentry', 'igmpentry', 'interface_array', 'item', 'key',
-		'lagg', 'lbaction', 'lbpool', 'l7rules', 'lbprotocol',
-		'member', 'menu', 'tab', 'mobilekey', 'monitor_type', 'mount',
+		'lagg', 'laggroup', 'lbaction', 'lbpool', 'l7rules', 'lbprotocol',
+		'member', 'menu', 'tab', 'mobilekey', 'mobilegroup', 'monitor_type', 'mount',
 		'npt', 'ntpserver',
 		'onetoone', 'openvpn-server', 'openvpn-client', 'openvpn-csc', 'option',
 		'package', 'passthrumac', 'phase1', 'phase2', 'ppp', 'pppoe', 'priv', 'proxyarpnet', 'pool',
diff --git a/src/etc/inc/xmlparse_attr.inc b/src/etc/inc/xmlparse_attr.inc
index 6d7c1e2053..b31914c663 100644
--- a/src/etc/inc/xmlparse_attr.inc
+++ b/src/etc/inc/xmlparse_attr.inc
@@ -168,7 +168,7 @@ function parse_xml_regdomain(&$rdattributes, $rdfile = '', $rootobj = 'regulator
 	return $rdmain;
 }
 
-function parse_xml_config_raw_attr($cffile, $rootobj, &$parsed_attributes, $isstring = "false") {
+function parse_xml_config_raw_attr($cffile, $rootobj, &$parsed_attributes) {
 
 	global $depth, $curpath, $parsedcfg, $havedata, $listtags, $parsedattrs;
 	$parsedcfg = array();
diff --git a/src/etc/pfSense-rc b/src/etc/pfSense-rc
index 34477abbce..21d16d5b3c 100755
--- a/src/etc/pfSense-rc
+++ b/src/etc/pfSense-rc
@@ -209,9 +209,7 @@ fi
 if [ -n "${USE_RAMDISK}" ]; then
 	/etc/rc.embedded
 	# Remount the correct subordinate ZFS datasets to ensure they are used properly
-	if [ -n "${USE_ZFS}" ]; then
-		_be_mount_zfs
-	fi
+	[ -n "${USE_ZFS}" ] && _be_mount_zfs
 fi
 
 # If RAM disks are active, make symlinks for pkg database on UFS
@@ -393,6 +391,9 @@ echo "done."
 /usr/bin/cap_mkdb /etc/login.conf
 
 if [ -f /cf/conf/needs_package_sync ]; then
+	# When restoring a configuration backup:
+	# - do not call pfSense-upgrade on boot
+	# - do not run rc.start_packages
 	skip_packages=1
 fi
 
@@ -553,8 +554,9 @@ if [ "${GMIRROR_STATUS}" != "" ]; then
 	/usr/local/bin/minicron 60 /var/run/gmirror_status_check.pid /usr/local/sbin/gmirror_status_check.php
 fi
 
-[ -z "$skip_packages" ] \
-	&& /usr/local/sbin/${product_name}-upgrade -y -U -b 3
+if [ -z "$skip_packages" ]; then
+	/usr/local/sbin/${product_name}-upgrade -y -U -b 3
+fi
 
 # Start packages
 [ -z "$skip_packages" ] \
@@ -563,17 +565,6 @@ fi
 # Update pkg metadata
 /etc/rc.update_pkg_metadata now
 
-# Log product version to syslog
-get_version
-BUILDTIME=`cat /etc/version.buildtime`
-ARCH=`uname -m`
-echo "$product_label ${version}${version_patch} $ARCH $BUILDTIME"
-
-echo "Bootup complete"
-echo "Bootup complete" | /usr/bin/logger
-
-/usr/local/bin/beep.sh start 2>&1 >/dev/null
-
 # Reset the cache.  read-only requires this.
 /bin/rm -f /tmp/config.cache
 
@@ -593,4 +584,15 @@ if [ -f /etc/rc.local ]; then
 	fi
 fi
 
+# Log product version to syslog
+get_version
+BUILDTIME=`cat /etc/version.buildtime`
+ARCH=`uname -m`
+echo "$product_label ${version}${version_patch} $ARCH $BUILDTIME"
+
+echo "Bootup complete"
+echo "Bootup complete" | /usr/bin/logger
+
+/usr/local/bin/beep.sh start 2>&1 >/dev/null
+
 exit 0
diff --git a/src/etc/rc.banner b/src/etc/rc.banner
index 000a498d31..79eab52b9f 100755
--- a/src/etc/rc.banner
+++ b/src/etc/rc.banner
@@ -33,6 +33,7 @@ $machine = trim(`uname -m`);
 
 /* Export the product variable. */
 if (is_writable("/etc")) {
+	$handle = NULL;
 	if (!file_exists("/etc/product_name") || is_writable("/etc/product_name"))
 		$handle = fopen("/etc/product_name", 'w');
 	if ($handle != NULL)
diff --git a/src/etc/rc.bootup b/src/etc/rc.bootup
index 4000815ae4..b6098a2d16 100755
--- a/src/etc/rc.bootup
+++ b/src/etc/rc.bootup
@@ -122,9 +122,6 @@ echo "done.\n";
 
 mwexec("/usr/sbin/gnid > {$g['vardb_path']}/uniqueid 2>/dev/null");
 
-/* run any early shell commands specified in config.xml */
-system_do_shell_commands(1);
-
 // Only do the alternate interface checks if:
 // 1) The user has not yet run the initial wizard; and
 // 2) The user has not used the console menu to setup interface assignments
@@ -170,11 +167,16 @@ while (is_interface_mismatch() == true) {
 	led_kitt();
 }
 
+/* enable optional crypto modules */
+echo "Loading cryptographic accelerator drivers...";
+load_crypto();
+echo "done.\n";
+
 echo "Checking config backups consistency...";
 cleanup_backupcache(true);
 echo "done.\n";
 
-/* read in /etc/sysctl.conf and set values if needed */
+/* set additional sysctls not defined in loader.conf */
 echo "Setting up extended sysctls...";
 system_setup_sysctl();
 echo "done.\n";
@@ -187,8 +189,10 @@ if (file_exists($file)) {
 	echo "done.\n";
 }
 
-/* enable optional crypto modules */
-load_crypto();
+/* run any early shell commands specified in config.xml */
+echo "Executing early shell commands...";
+system_do_shell_commands(1);
+echo "done.\n";
 
 /* enable optional thermal sensor modules */
 load_thermal_hardware();
diff --git a/src/etc/rc.initial.reboot b/src/etc/rc.initial.reboot
index 80b95e2e3c..4d071818ac 100755
--- a/src/etc/rc.initial.reboot
+++ b/src/etc/rc.initial.reboot
@@ -45,7 +45,7 @@ if (!is_module_loaded("zfs.ko")) {
 
 echo gettext("Enter an option:") . " ";
 
-switch (chop(fgets($fp))) {
+switch (strtoupper(chop(fgets($fp)))) {
 	case "S":
 		mwexec('/sbin/nextboot -o "-s" -k kernel');
 		$msg = sprintf(gettext("%s is rebooting into single user mode now."), $g['product_label']);
@@ -70,7 +70,8 @@ switch (chop(fgets($fp))) {
 		system_reboot_sync(true);
 		break;
 	case "Y":
-	case "y":
+	case "YE":
+	case "YES":
 		$msg = sprintf(gettext("%s is rebooting now."), $g['product_label']);
 		echo "\n" . $msg . "\n";
 		notify_all_remote($msg);
diff --git a/src/etc/rc.php_ini_setup b/src/etc/rc.php_ini_setup
index d11b9132b5..6c6d05dd5e 100755
--- a/src/etc/rc.php_ini_setup
+++ b/src/etc/rc.php_ini_setup
@@ -45,14 +45,16 @@ else
 	AVAILMEM=$(/sbin/dmesg -a |/usr/bin/awk '/avail memory/ { memory=($4 / 1048576); printf("%0.0f\n", memory); exit}')
 fi
 
+# Use hw.physmem if $AVAILMEM is zero
 if [ -z "$AVAILMEM" ]; then
-	MEM=$(/sbin/sysctl -q hw.physmem | cut -d':' -f2)
-	AVAILMEM=$(/bin/expr $MEM / 1048576)
+	AVAILMEM=$(/sbin/sysctl -qn hw.physmem | /usr/bin/awk '{print $1/1048576}' | /usr/bin/awk -F '.' '{print $1}')
 fi
 
-
 # Get amount of ram installed on this system
-REALMEM=$(/sbin/sysctl -q hw.realmem | /usr/bin/awk '{print $2/1048576}' | /usr/bin/awk -F '.' '{print $1}')
+REALMEM=$(/sbin/sysctl -qn hw.realmem | /usr/bin/awk '{print $1/1048576}' | /usr/bin/awk -F '.' '{print $1}')
+if [ -z "$REALMEM" -o "$REALMEM" == "0" ]; then
+	REALMEM=$AVAILMEM
+fi
 export REALMEM
 export LOWMEM
 
@@ -81,6 +83,8 @@ else
 	fi
 fi
 
+PCRE_JIT=1
+
 # Set upload directory
 UPLOADTMPDIR="/tmp"
 
@@ -214,6 +218,9 @@ session.hash_function = 1
 ${error_reporting}
 ${exception_ignore_args}
 
+[Pcre]
+pcre.jit=${PCRE_JIT}
+
 ; Extensions
 
 EOF
diff --git a/src/etc/rc.restore_config_backup b/src/etc/rc.restore_config_backup
index 43c01145e3..8b45ec6946 100755
--- a/src/etc/rc.restore_config_backup
+++ b/src/etc/rc.restore_config_backup
@@ -57,7 +57,7 @@ function choose_backup() {
 	echo " 1-" . count($confvers) . " : ";
 	$number = strtoupper(chop(fgets($fp)));
 	if (is_numeric($number) && ($number > 0) && ($number <= count($confvers))) {
-		return $number;
+		return intval($number);
 	} else {
 		echo gettext("That is not a valid backup number.\n");
 		return -1;
@@ -74,7 +74,7 @@ function restore_history_backup($number) {
 		echo gettext("Y/N?") . " : ";
 		$confirm = strtoupper(chop(fgets($fp)));
 		if ($confirm == gettext("Y")) {
-			if (config_restore($g['conf_path'] . '/backup/config-' . $thisbackup['time'] . '.xml') == 0) {
+			if (config_restore($g['conf_path'] . '/backup/config-' . $thisbackup['time'] . '.xml', $thisbackup['description'])) {
 				echo "\n";
 				echo sprintf(gettext('Successfully reverted to timestamp %1$s with description "%2$s".'), date(gettext("n/j/y H:i:s"), $thisbackup['time']), $thisbackup['description']);
 				echo "\n" . gettext("You may need to reboot the firewall or restart services before the restored configuration is fully active.") . "\n\n";
diff --git a/src/usr/local/pfSense/include/www/backup.inc b/src/usr/local/pfSense/include/www/backup.inc
index 9544114bb1..07c589af98 100644
--- a/src/usr/local/pfSense/include/www/backup.inc
+++ b/src/usr/local/pfSense/include/www/backup.inc
@@ -252,7 +252,7 @@ function execPost($post, $postfiles, $ui = true) {
 					} else {
 
 						/* read the file contents */
-						$data = $ui ? file_get_contents($postfiles['conffile']['tmp_name']) : $postfiles['conffile']['tmp_name'];
+						$data = file_get_contents($postfiles['conffile']['tmp_name']);
 						if (!$data) {
 							$input_errors[] = gettext("Warning, could not read file {$postfiles['conffile']['tmp_name']}");
 						} elseif ($post['decrypt']) {
